//
// Created by william on 1/6/24.
//

#ifndef NESEMULATOR_MEMORY_VIEW_H
#define NESEMULATOR_MEMORY_VIEW_H

#include <panel.h>
#include "../include/types.h"

#define MEMORY_VIEW_HEIGHT 19
#define MEMORY_VIEW_WIDTH 56
#define MEMORY_VIEW_LINE_COUNT 0xf
#define MEMORY_VIEW_LINE_BYTE_COUNT 0xf
#define MEMORY_VIEW_BYTE_COUNT 0xff

#define MEMORY_VIEW_DIRECTION_UP 1
#define MEMORY_VIEW_DIRECTION_DOWN -1

typedef struct memory_view {
    PANEL *panel;
    address base_address;
} MemoryView;

void memory_view_init(MemoryView *view, ram ram);

void memory_view_print(MemoryView *view, ram ram);

void memory_view_goto(MemoryView *view, address target, ram ram);

void memory_view_scroll(MemoryView *view, char direction, ram ram);

#endif //NESEMULATOR_MEMORY_VIEW_H
